Subject: Re: [PATCH v2 0/6] perf parse-regs: Refactor architecture functions

From: Arnaldo Carvalho de Melo <[email-masked]>
Date: Tue, 15 Aug 2023 15:24:04 -0300

Em Wed, Jul 12, 2023 at 03:37:36PM -0700, Ian Rogers escreveu:
> On Mon, Jun 5, 2023 at 6:46 PM Leo Yan <[email-masked]> wrote:
> >
> > This patch series is to refactor arch related functions for register
> > parsing, which follows up the discussion for v1:
> > https://lore.kernel.org/lkml/[email-masked]/
> >
> > Compared to patch series v1, this patch series introduces new functions
> > perf_arch_reg_{ip|sp}(), so this can allow the tool to support cross
> > analysis.
> >
> > To verify the cross analysis, I used below steps:
> >
> > - Firstly, I captured perf data on Arm64 machine:
> >
> >   $ perf record --call-graph fp -- ./test_program
> >
> >   Or ...
> >
> >   $ perf record --call-graph dwarf -- ./test_program
> >
> >   Then, I also archived associated debug data:
> >
> >   $ perf archive
> >
> > - Secondly, I copied the perf data file and debug tar file on my x86
> >   machine:
> >
> >   $ scp perf.data perf.data.tar.bz2 leoy@IP_ADDRESS:/target/path/
> >
> > - On x86 machine, I need to build perf for support multi-arch unwinding:
> >
> >   $ git clone http://git.savannah.gnu.org/r/libunwind.git
> >   $ cd libunwind
> >   $ autoreconf -i
> >
> >   # Build and install libunwind aarch64:
> >   $ ./configure prefix=/home/leoy/Work/tools/libunwind/install/ \
> >         --target=aarch64-linux-gnu CC=x86_64-linux-gnu-gcc
> >   $ make && make install
> >
> >   # Build and install libunwind x86:
> >   $ ./configure prefix=/home/leoy/Work/tools/libunwind/install/ \
> >         --target=x86_64-linux-gnu CC=x86_64-linux-gnu-gcc
> >   $ make && make install
> >
> > - Build perf tool for support multi-archs:
> >
> >   $ cd $LINUX/tools/perf
> >   $ make VF=1 DEBUG=1 LIBUNWIND_DIR=/home/leoy/Work/tools/libunwind/install
> >
> > At the end, I verified the x86 perf tool can do cross analysis for aarch64's
> > perf data file.
> >
> > Note, I still see x86 perf tool cannot display the complete callgraph
> > for aarch64, but it should not the issue caused by this series, which
> > will be addressed by separate patches.
> >
> > I also built this patch series on my Arm64 and x86 machines, both can
> > compile perf tool successfully; but I have no chance to build other
> > archs natively.
> >
> > Changes from v1:
> > - For support cross analysis for IP/SP registers, introduced patch 0002
> >   (James Clark, Ian Rogers).
> >
> >
> > Leo Yan (6):
> >   perf parse-regs: Refactor arch register parsing functions
> >   perf parse-regs: Introduce functions perf_arch_reg_{ip|sp}()
> >   perf unwind: Use perf_arch_reg_{ip|sp}() to substitute macros
> >   perf parse-regs: Remove unused macros PERF_REG_{IP|SP}
> >   perf parse-regs: Remove PERF_REGS_{MAX|MASK} from common code
> >   perf parse-regs: Move out arch specific header from util/perf_regs.h
> 
> Sorry for the slow review. For the series:
> Acked-by: Ian Rogers <[email-masked]>
> 
> Some thoughts:
> uint64_t __perf_reg_ip_arm(void)
> uint64_t seems like we're giving a lot of space for future register
> encodings. I think some of the other functions use this size of value
> due to returning a bitmap/mask, but here it isn't clear and just feels
> excessive.
> 
> Do we need the "__" prefix on all the functions?
> 
> In Makefile.config there are NO_PERF_REGS and CONFIG_PERF_REGS then
> the define HAVE_PERF_REGS_SUPPORT. Is this still relevant? If we had
> an architecture with no support, couldn't it still read a perf.data
> file from a supported architecture? It would be nice to remove at
> least NO_PERF_REGS and HAVE_PERF_REGS_SUPPORT.
> 
> This change is very worthwhile fix and cleanup, it didn't introduce
> what is pondered above, hence the acked-by.

Agreed, applied to perf-tools-next, sorry for the delay.

- Arnaldo

_______________________________________________
linux-arm-kernel mailing list
[email-masked]
http://lists.infradead.org/mailman/listinfo/linux-arm-kernel